<template>
  <div class="project pagePadding">
    <div
      v-if=" powers.some((i) => i == '001')"
    >
      <ex-table
        v-loading="loading"
        :table="table"
        :data="tableData"
        :columns="columns"
        :page="pageInfo"
        :size="size"
        @page-curr-change="handlePageChange"
        @page-size-change="handleSizeChange"
        @screen-reset="
          pageInfo.curr = 1;
          parmValue.page = 1;
          searchList();
        "
        @screen-submit="
          pageInfo.curr = 1;
          parmValue.page = 1;
          searchList();
        "
      >
        <template #table-header="{}">
          <div style="width: 100%">
            <el-row style="padding: 0 0 0 80px">
              <el-col :span="24">
                <el-col :span="4" style="width: 140px">
                  <el-select
                    :size="searchSize"
                    v-model="parmValue.status"
                    filterable
                    clearable
                    placeholder="项目状态"
                    style="width: 100%"
                    @change="
                      pageInfo.curr = 1;
                      parmValue.page = 1;
                      searchList();
                    "
                  >
                    <el-option
                      v-for="item in statusOptions"
                      :key="'project' + item.id"
                      :label="item.label"
                      :value="item.id"
                    />
                  </el-select>
                </el-col>
                <el-col :span="6" style="width: 303px; padding: 0 0 0 10px">
                  <period-date-picker
                    :start="parmValue.start"
                    :end="parmValue.end"
                    :type="1"
                    :width="'135px'"
                    :size="searchSize"
                    @timeReturned="timeReturned($event)"
                  />
                </el-col>
                <el-col :span="6" style="width: 303px; padding: 0 0 0 10px">
                  <number-range
                    :lower="parmValue.low"
                    :online="parmValue.up"
                    :type="1"
                    :width="'135px'"
                    :title="'总预算'"
                    :size="searchSize"
                    @numReturned="numReturned($event)"
                  />
                </el-col>

                <el-col :span="3" style="width: 66px; float: right">
                  <el-button
                    :size="searchSize"
                    type="primary"
                    style="float: right; margin-left: 5px"
                    @click="searchList"
                  >
                    刷新
                  </el-button>
                </el-col>
                <el-col :span="4" style="width: 66px; float: right">
                  <el-button
                    type="warning"
                    class="fr"
                    :size="searchSize"
                    @click="restSearch"
                  >
                    重置
                  </el-button>
                </el-col>
              </el-col>
            </el-row>
            <el-row style="padding: 10px 0 0 0">
              <el-col :span="24">
                <el-col :span="4" style="width: 355px">
                  <search-customer
                    :value="customerCode"
                    :size="searchSize"
                    :placeholder="'客户公司名称'"
                    :names="parmValue.supplierName"
                    :is-detail="true"
                    @searchChange="customerChange"
                  />
                </el-col>
                <el-col :span="4" style="width: 320px; padding: 0 0 0 10px">
                  <el-input
                    placeholder="项目名称"
                    v-model="parmValue.project_name"
                    :size="searchSize"
                    maxlength="100"
                    @blur="
                      pageInfo.curr = 1;
                      parmValue.page = 1;
                      searchList();
                    "
                  >
                  </el-input>
                </el-col>

                <el-col :span="4" style="width: 170px; padding: 0 0 0 10px">
                  <el-input
                    placeholder="申请人部门"
                    v-model="parmValue.company_name"
                    :size="searchSize"
                    maxlength="100"
                    @blur="
                      pageInfo.curr = 1;
                      parmValue.page = 1;
                      searchList();
                    "
                  >
                  </el-input>
                </el-col>

                <el-col
                  :span="3"
                  class="fr"
                  style="width: 66px; padding: 0 0 0 10px"
                  v-if="powers.some((i) => i == '003')"
                >
                  <el-button
                    :size="searchSize"
                    type="success"
                    style="float: right"
                    @click="
                      routeGoto('projectDetail', { id: 'add', type: 'add' })
                    "
                  >
                    添加
                  </el-button>
                </el-col>
              </el-col>
            </el-row>
          </div>
        </template>
        <template #low_rate="{ scope }">
          <el-tag
            v-if="scope.row"
            :type="parseInt(scope.row.low_rate) == 0 ? 'danger' : ''"
            :size="tablebtnSize"
            v-text="parseInt(scope.row.low_rate) == 0 ? '未设置' : '已设置'"
          ></el-tag>
        </template>
        <template #status="{ scope }">
          <el-tag
            :size="tablebtnSize"
            v-text="
              (statusOptions.find((item) => item.id == scope.row.status) || {})
                .label || '--'
            "
          ></el-tag>
        </template>
        <template #operation="{ scope }">
          <el-tooltip
            v-if="powers.some((i) => i == '007')"
            effect="dark"
            content="详情"
            placement="top"
          >
            <i
              class="el-icon-view tb-icon"
              
               @click="getRouter('projectDetail', scope.row.projectNo )"
            ></i>
          </el-tooltip>
        </template>
      </ex-table>
    </div>
    <div v-else>
      <no-auth></no-auth>
    </div>
  </div>
</template>
   <script>
import mixinPage from "@/mixins/elPaginationHandle";
import resToken from "@/mixins/resToken";
import asyncRequest from "@/apis/service/sellOut/project";
import { mapGetters } from "vuex";
import columns from "./columns";
export default {
  name: "project",
  mixins: [mixinPage, resToken],
  computed: {
    ...mapGetters(["tablebtnSize", "searchSize", "size"]),
    powers() {
      const tran =
        this.$store.getters.btnList.find(
          (item) => item.menu_route == "project"
        ) || {};
      const { action } = tran ?? {};
      return action ?? [];
    },
  },
  data() {
    return {
      select: "1",
      input: "",
      addShowModel: false,
      addModelId: "",
      addIsDetail: false,
      supplierName:"",
      customerCode: [],
      sitem: null,
      // 状态
      statusOptions: [
        { id: "1", label: "待商品反馈" },
        { id: "2", label: "待客户选择商品" },
        { id: "3", label: "待项目方案制定" },
        { id: "4", label: "待方案选择" },
        { id: "5", label: "项目待下单" },
        { id: "6", label: "项目已结束" },
      ],

      loading: true,
      showModel: false,
      isDetail: false,
      modelId: 0,
      parmValue: {
        start: "",
        end: "",
        page: 1, // 页码
        size: 15, // 每页显示条数
        khNo: "", // 客户编码
        status: "",
        project_name: "",
        low: "",
        up: "",
        company_name:"",
      },
      tableData: [],
      passwordModel: false,
      passwordModelId: 0,
      isPasswordDetail: false,
      // 表格 - 数据
      tableData: [],
      // 表格 - 参数
      table: {
        stripe: true,
        border: true,
        _defaultHeader_: ["setcol"],
      },
      // 表格 - 分页
      pageInfo: {
        size: 15,
        curr: 1,
        total: 0,
      },
      // 表格 - 列参数
      columns: columns,
    };
  },
  mounted() {
    const { back } = this.$route.query;
    if (back) {
      this.parmValue = JSON.parse(back);
      console.log(this.parmValue)
      const {page,size}=this.parmValue;
      // this.parmValue.start = start || last_start;
      // this.parmValue.end = end || last_end;
      if(this.parmValue.khNo.length>0){
          this.customerCode = [this.parmValue.khNo] ;
      }
      
       this.pageInfo= {
        size: size,
        curr: page,
        total: 0,
      }
      //多选条件
    // this.select = this.parmValue.select;
    // this.sselect = this.parmValue.sselect;
    // this.s_input = this.parmValue.s_input

    }else{
      //  this.select = "cgdNo";
      //  this.sselect = "创建时间"
    }
    this.searchList();
  },

  methods: {
    getRouter(toRouter, queryId){
      if (toRouter && queryId) {
        let model = {
          id: queryId,
          type: 'view',
        };

        //有多选框的条件
        // this.parmValue.select = this.select ;
        // this.parmValue.sselect = this.sselect ;
        // this.parmValue.s_input= this.s_input;
        //
         let routerModel = {
          options: JSON.parse(JSON.stringify(this.parmValue)),
          router: this.$route.path,
        };
        model.preModel = JSON.stringify(routerModel);
        
        this.routeGoto(toRouter, model);
      } else {
        this.$message.warning("暂未找到相关流程！");
      }
    },
    async timeReturned(e) {
      if (e.startTime !== "") {
        this.parmValue.start = e.startTime;
      } else {
        this.parmValue.start = "";
      }

      if (e.endTime !== "") {
        this.parmValue.end = e.endTime;
      } else {
        this.parmValue.end = "";
      }
      if (this.parmValue.start !== "" && this.parmValue.end !== "") {
        this.parmValue.page = 1;
        await this.searchList();
      }
    },
    restSearch() {
      // 表格 - 分页
      this.pageInfo = {
        size: 15,
        curr: 1,
        total: 0,
      };
      this.select = "1";
      this.input = "";
      this.customerCode = [];
      this.parmValue = {
        start: "",
        end: "",
        page: 1, // 页码
        size: 15, // 每页显示条数
        khNo: "", // 客户编码
        status: "",
        project_name: "",
        low: "",
        up: "",
        company_name:"",
      };
      this.searchList();
    },
    async customerChange(e) {
      if (e && e.id) {
        this.customerCode = [e.code];
        this.parmValue.supplierName = e.label;
        this.parmValue.khNo = e.code;
      } else {
        this.customerCode = [];
        this.parmValue.supplierName = '';

        this.parmValue.khNo = "";
      }
      this.pageInfo.curr = 1;
      this.parmValue.page = 1;
      await this.searchList();
    },
    async numReturned(e) {
      const { lower, online } = e;
      this.parmValue.low = lower;
      this.parmValue.up = online;
      this.pageInfo.curr = 1;
      this.parmValue.page = 1;
      await this.searchList();
    },
    addModal(id, isDetail) {
      this.addShowModel = true;
      this.addModelId = id;
      this.addIsDetail = isDetail;
    },
    async deleteById(id, status) {
      await this.$confirm("确定要删除？", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning",
      })
        .then(async () => {
          const model = {
            id: id,
            // status: status === "1" ? "0" : "1",
          };
          const res = await asyncRequest.delete(model);
          if (res && res.code === 0) {
            this.$notify.success({
              title: "删除成功",
              message: "",
            });
            this.searchList();
          } else if (res && res.code >= 100 && res.code <= 104) {
            await this.logout();
          } else {
            this.$message.warning(res.message);
          }
        })
        .catch(() => {
          console.log("取消");
        });
    },
    async searchList() {
      if (
        (this.parmValue.start !== "" && this.parmValue.end === "") ||
        (this.parmValue.start === "" && this.parmValue.end !== "")
      ) {
        this.$message.warning("时间区间不完整！");
        return;
      }
      this.loading = true;
      const res = await asyncRequest.list(this.parmValue);
      if (res && res.code === 0 && res.data) {
        this.tableData = res.data.list;
        this.tableData.map((v) => {
          v.sale_price = this.setNum(v.sale_price);
          v.sale_fee = this.setNum(v.sale_fee);
          v.class_cat = "";
          if (v.can && v.can.length > 0) {
            v.can.forEach((x, i) => {
              v.class_cat += i === 0 ? x.name : "/" + x.name;
            });
          }
          return v;
        });
        this.pageInfo.total = Number(res.data.count);
      } else if (res && res.code >= 100 && res.code <= 104) {
        await this.logout();
      } else {
        this.tableData = [];
        this.pageInfo.total = 0;
      }
      this.loading = false;
    },
  },
};
</script>
   <style lang="scss" scoped>
.project {
}
</style>
   